.CSEG
;**************************************************************************************
;* serverBOTAVR: Module -> Analog/Digital Converter Controller Module
;* Description:	The ADC module handles the initialization of the analog/digital
;*		converter and controls the sampling of the ADC
;**************************************************************************************
;************************************************************************
;* Subroutine: Init_ADC
;* Initializes the A2D Converter and sets up the ADCLK as CLK/32 and
;* setup the ADC to do freerun mode
;************************************************************************
Init_ADC:	ldi TEMP, $00
		out ADMUX, TEMP
		
		ldi TEMP, $E5
		out ADCSR, TEMP
		
		ret
;************************************************************************
;* Subroutine: Disable ADC
;************************************************************************
Diable_ADC:	cbi ADCSR, 7
		ret
;************************************************************************
;* Subroutine: ADC_OneRun
;* Description: Samples the ADC using the input GENIOI as the select
;* for the ADCMUX and returns the result in GENIOI, GENIOR
;* Input: GENIOI
;* Output: GENIOR(Low),GENIOI(High)
;************************************************************************
ADC_OneRun:	out ADMUX, GENIOI
		sbi ADCSR, 4		;Clear the Conv Complete Flag
		
OneRun_Init:	sbis ADCSR, 4		;Wait for previous Conv
		rjmp OneRun_Init
		
		sbi ADCSR, 4		;Clear the Conv Complete Flag
		
Sample_Wait:	sbis ADCSR, 4		;New Conv, updated to reflect
		rjmp Sample_Wait	;ADMUX change
		
;		sbi ADCSR, 4				
		in GENIOR, ADCL
		in GENIOI, ADCH
		ret
;************************************************************************
ADC_8bit:	push GENIOR
		out ADMUX, GENIOI
		sbi ADCSR, 4		;Clear the Conv Complete Flag
		
ADC8bit_Init:	sbis ADCSR, 4		;Wait for previous Conv
		rjmp ADC8bit_Init
		
		sbi ADCSR, 4		;Clear the Conv Complete Flag
		
ADC8bit_Wait:	sbis ADCSR, 4		;New Conv, updated to reflect
		rjmp ADC8bit_Wait	;ADMUX change
		
;		sbi ADCSR, 4				
		in GENIOR, ADCL
		in GENIOI, ADCH
		ror GENIOI
		ror GENIOR
		ror GENIOI
		ror GENIOR
		mov GENIOI, GENIOR
		pop GENIOR
		ret			