.CSEG
;**************************************************************************************
;* serverBOTAVR: Module -> User Debug Interface
;* Description: The User Debug Interface (UDI) Allows the User to access a Debug Menu
;*		for the serverBOT. The UDI includes a UART Serial Communications Suite
;*		Along with the Main Menu Code.
;**************************************************************************************
;--= ASCII DEFINITIONS =--

.equ	EOS	=$04
.equ	CR	=$0D
.equ	LF	=$0A
.equ	ESC	=$1B
;***************************************************************************		
;*			SUBROUTINE - Display_Menu
;***************************************************************************
DisplayMnu:	rcall Init_UART
		rcall LEDS_OFF
		;ldi SYSTMP, high(Basic_Main)
		;ldi SYSTMP2, low(Basic_Main)
		;rcall Begin_PS
		
Dis_Menu:	DISP_STRING	ClrScr		; ASSEMBLER MACRO - Clear Screen		
Dis_Menu2:	DISP_STRING	Title		; ASSEMBLER MACRO - Display Title
		DISP_STRING	Selection	; ASSEMBLER MACRO - Display Menu
		DISP_STRING	Prompt		; ASSEMBLER MACRO - Display Prompt

		rcall InChar			; Get Character Input

		subi GENIOI, $30			; 
		cpi GENIOI, $01			;
		breq Option1			;
		cpi GENIOI, $02			;
		breq Option2			;
		cpi GENIOI, $03			;
		breq Option3
		cpi GENIOI, $04
		breq Option4
		cpi GENIOI, $05
		breq GetVars
		
Invalid:	DISP_STRING	ClrScr		; ASSEMBLER MACRO - Clear Screen
		DISP_STRING	InvEntry	; ASSEMBLER MACRO - Display Invalid Entry
		rjmp Dis_Menu2			;
					;
IDLE:		rjmp IDLE			;

Option1:	;DISP_STRING	Offset		;
;		rcall InChar
;		rcall OutChar
;		subi GENIOI, $30
;		mov GENIOR, GENIOI
;		swap GENIOR
;		rcall InChar
;		rcall OutChar
;		subi GENIOI, $30
;		add GENIOI, GENIOR
		ldi GENIOI, $11
		mov M_TMP, GENIOI
		rcall Init_Motors
		rcall M_Turn_Right
		rcall InChar
		rjmp Dis_Menu

Option2:	;DISP_STRING	Offset		;
		;rcall InChar
		;rcall OutChar
		;subi GENIOI, $30
		;mov GENIOR, GENIOI
		;swap GENIOR
		;rcall InChar
		;rcall OutChar
		;subi GENIOI, $30
		;add GENIOI, GENIOR
		ldi GENIOI, $0D
		mov M_TMP, GENIOI
		rcall Init_Motors
		rcall M_Turn_Left
		rcall InChar		
		rjmp Dis_Menu			;
		
Option3:	;cbr STATUS, $10
		ldi ND_CNT, $04
		rcall Init_Motors
		rjmp MOT_DBG
		rjmp Dis_Menu

Option4:	rjmp ADC_Sample
		rjmp Dis_Menu

GetVars:	lds GENIOI, NFSR_H
		rcall HEX2ASCII
		lds GENIOI, NFSR_L
		rcall HEX2ASCII
		lds GENIOI, NCDS_H
		rcall HEX2ASCII
		lds GENIOI, NCDS_L
		rcall HEX2ASCII
		rcall InChar
		rjmp Dis_Menu

MOT_DBG:	rcall Motion_Sweep
		rcall Analyze_MOT
		in TEMP, USR		; check for RXC
		andi TEMP, 0b10000000	;
		breq MOT_DBG
		
		in GENIOI, UDR
		cpi GENIOI, ESC
		brne MOT_DBG
		rcall InChar
		rjmp Dis_Menu
	
;Motion_Loop:	rcall TIM2_PWM
;		rcall Motion_Sweep
;		CALL_TIMER2	CATimeout,$01,$7F	;Assembler Macro See server_v1.asm
;		rcall TIM2_TIMER
;ML_WAIT:	sbrc STATUS, 0
;		rjmp Motion_Loop
;		rjmp ML_WAIT
;		rjmp Dis_Menu
		
;enableLED:	ldi r17, $00			;
;		out PORTB, r17			;
;		ret

;disableLED:	ldi r17, $FF			;
;		out PORTB, r17			;
;		ret

ADC_Sample:	rcall Init_ADC
		DISP_STRING	ClrScr
Sample_AGN:	DISP_STRING	txtIR1
		ldi GENIOI, $06
		rcall ADC_8bit
		rcall HEX2ASCII
		;rcall ADC_OneRun
		;rcall HEX2ASCII
		;mov GENIOI, GENIOR
		;rcall HEX2ASCII
		
		;DISP_STRING	txtIR2
		;ldi GENIOI, $01
		;rcall ADC_8bit
		;rcall HEX2ASCII
		;rcall ADC_OneRun
		;rcall HEX2ASCII
		;mov GENIOI, GENIOR
		;rcall HEX2ASCII
		;DISP_STRING	txtMSensor
		;ldi GENIOI, $02
		;rcall ADC_OneRun
		;rcall HEX2ASCII
		;mov GENIOI, GENIOR
		;rcall HEX2ASCII
;		DISP_STRING	txtPSensor
;		ldi GENIOI, $03
;		rcall ADC_OneRun
;		rcall HEX2ASCII
;		mov GENIOI, GENIOR
;		rcall HEX2ASCII
;		DISP_STRING	txtIR3
;		ldi GENIOI, $04
;		rcall ADC_OneRun
;		rcall HEX2ASCII
;		mov GENIOI, GENIOR
;		rcall HEX2ASCII
		;DISP_STRING	txtIR4
		;ldi GENIOI, $05
		;rcall ADC_OneRun
		;rcall HEX2ASCII
		;mov GENIOI, GENIOR
		;rcall HEX2ASCII
;		DISP_STRING	txtCDS
;		ldi GENIOI, $06
;		rcall ADC_OneRun
;		rcall HEX2ASCII
;		mov GENIOI, GENIOR
;		rcall HEX2ASCII
;		
		ldi GENIOI, CR
		rcall OutChar
		in TEMP, USR
		andi TEMP, 0b10000000
		breq Sample_AGN
		in GENIOI, UDR
		cpi GENIOI, ESC
		brne Sample_AGN
		rjmp Dis_Menu					
;***************************************************************************		
;*			SUBROUTINE - Init_UART
;* Description: Initializes the UART, enabling the Transmitter and Receiver
;*		and setting the baud rate.
;* Input: None
;* Output: None
;* Uses: TEMP
;***************************************************************************	
Init_UART:	;ldi TEMP, $FF			;
		;out DDRB, TEMP			;
		;out PORTB, TEMP			; Turn Off LEDS default
		
		ldi TEMP,$19 			; Sets the Baud Rate Register
		out UBRR, TEMP 			; 0C = 19200 @ 4Mhz
						; 19 = 19200 @ 8Mhz
						; 33 = 9600 @ 8Mhz
		
		sbi UCR, 3			;Enable Transmitter
		sbi UCR, 4			;Enable Receiver
		
		ret	
;***************************************************************************			
Init_LEDS:	ldi TEMP, $FF
		out DDRB, TEMP
		out PORTB, TEMP
		out DDRC, TEMP
		out PORTC, TEMP
		ret
;***************************************************************************
;*			SUBROUTINE - OutStr
;* Description: This subroutine Outputs to the uart the string referenced
;*		by the Z-Index Register. When an EOS Byte denotes the end
;*		of the string to be transmitted.
;* Input: Location of String stored in Z-Index Registers
;* Output: String Outputted to UART/Display
;* Uses: TEMP, TEMP2, r0
;***************************************************************************	
OutStr:		lpm			; Get Data from Z[]
		mov TEMP, r0		; Move Data to r20
		cpi TEMP, EOS		; Check if EOS
		breq Ex_OStr		; If EOS goto end
		adiw ZL,1		; else increment Z and continue
		
OutStrW:	in TEMP2, USR		; Check for UDRE
		andi TEMP2, 0b00100000	;
		breq OutStrW		;
		
		out UDR, r0		; Output Data to UDR
		rjmp OutStr		; get next character
		
Ex_Ostr:	ret			; return from subroutine

OutStr2:	out EEARH, ZH
		out EEARL, ZL
		sbi EECR, 0
		in TEMP, EEDR
		cpi TEMP, EOS
		breq EX_OSTR2
		inc ZL
		
OutStrW2:	in TEMP2, USR
		andi TEMP2, 0b00100000
		breq OutStrW2
		
		out UDR, TEMP
		rjmp OutStr2
EX_OSTR2:	ret
;***************************************************************************	
;*			SUBROUTINE - InChar
;* Description: This subroutine waits for input to the UART and returns
;* 		the inputted data in RECVD Stack
;* Input: 1 Byte Input from UART RX
;* Output: Inputted Data stored in RECVD[0] to be used immediately after
;*	   subroutine. This data is not guaranteed because RECVD is also
;*	   used by other subroutines and can be overwritten if not used
;*	   immediately
;* Uses: TEMP, GENIOR
;***************************************************************************
InChar:		in TEMP, USR		; check for RXC
		andi TEMP, 0b10000000	;
		breq InChar		;
		
		in GENIOI, UDR		; Get Data Input from UDR
		
		ret			; return from subroutine
;***************************************************************************	
;*			SUBROUTINE - OutChar (~12 Cycles)
;* Description: This subroutine waits for input to the UART and returns
;* 		the inputted data in RECVD Stack
;* Input: 1 Byte Input via GENIO(r21)
;* Output: Output Data Byte to UART TX
;* Uses: GENIOI, TEMP
;***************************************************************************		
OutChar:	in TEMP, USR		; Check for UDRE
		andi TEMP, 0b00100000	;to send byte
		breq OutChar
		
		out UDR, GENIOI		; Send Byte

		ret
;*
;***************************************************************************	
;*			SUBROUTINE - HEX2ASCII (~74 Cycles)
;* Description: This subroutine prints the Hex Equivalent of the 
;*              Byte Located in COUNT(r25) out to the UART
;* Uses: two temp registers r18
;* Input: 1 Byte Input via GENIO(Universal Input)
;* Output: Output Hex Equivalent of Byte to UART followed by a space.
;***************************************************************************
HEX2ASCII:	push GENIOI		; push GENIO				
		andi GENIOI, $F0	; remove lower nibble of r18		
		swap GENIOI		; swap upper nibble to lower nibble					
		cpi GENIOI, $0A		; Check if Byte >= $0A	
		brsh AF1		; If so goto AF1			
		ldi TEMP, $30		; Load $30 into r19			
		add GENIOI, TEMP		; decimal to ASCII			
SENDHBH:	rcall OutChar		;						
		pop GENIOI		; pop COUNT				
		andi GENIOI, $0F		; remove upper nibble of r18
					
		cpi GENIOI, $0A		; Check if byte >= $0A			
		brsh AF2		; If so goto AF2		
		ldi TEMP, $30		; load $30 into r19		
		add GENIOI, TEMP		; decimal to ASCII			
SENDHBL:	rcall OutChar		; Print to Screen
				
		ldi GENIOI, $20		; load COUNT with space		
		rcall OutChar					
		ret			; Return from subroutine			

AF1:		subi GENIOI, $0A		; subtract 0A from r18 to get offset	
		ldi TEMP, $41		; Add 41 to get A-F Offset		
		add GENIOI, TEMP						
		rjmp SENDHBH		; jump to SENDHBH				
		
AF2:		subi GENIOI, $0A		; subtract r18 - $0A for offset
		ldi TEMP, $41		; Add $41 to get A-F
		add GENIOI, TEMP
		rjmp SENDHBL		; jump to SENDHBL
;*	
;****************************************************************************
;* Hard Coded User Menu Display Constants
;****************************************************************************
.ESEG
.ORG	0x000
nxtline:
		.db	CR,LF
		.db	EOS
ClrScr:		
		.db	ESC,$5B,$32,$4A
		.db	ESC,$5B,$3B,$48
		.db	EOS
Title:
		.db	"*** serverBOT User Debug Interface - Main Menu - Version 1.00 ***"
		.db	CR,LF,EOS
Selection:
		.db	"1. Turn Motors Left"
		.db	CR,LF
		.db	"2. Turn Motors Right"
		.db	CR,LF
		.db	"3. Check ADC"
		.db	CR,LF
		.db	EOS
Prompt:
		.db	"Selection: "
		.db	EOS
InvEntry:
		.db	"! Invalid Entry"
		.db	CR,LF
		.db	EOS
Offset:
		.db	"Offset: "
		.db	EOS
txtIR1:
		.db	"Left IR: "
		.db	EOS
txtIR2:
		.db	"Right IR: "
		.db	EOS
txtMSensor:
		.db	"Motion: "
		.db	EOS
txtPSensor:
		.db	"Pressure: "
		.db	EOS
txtIR3:
		.db	"Top_R IR: "
		.db	EOS
txtIR4:
		.db	"Top_L IR: "
		.db	EOS
.ORG	0x100
txtCDS:
		.db	"CDS: "
		.db	EOS